%
% Process an event
%
function [sig, sn, cm] = process_event(ievt, S, pedestal, noise)
  sz       = size(pedestal);
  nchan    = sz(1);
  nchip    = nchan/128;

  % Signal without pedestals
  sig = (single ( S(:,ievt) ) - pedestal);
  
  % compute and subtract common mode
  cm = zeros(nchip,1);
  for i = 1:nchip
    cm(i) = mean(sig(128*(i-1)+1:128*i));
    %%sig(128*(i-1)+1:128*i) -= cm(i);
  end
  
  % compute signal/noise
  sn = sig./noise;

end
