/*
 * gthread-compat.h
 *
 *  Created on: Jun 15, 2016
 *      Author: lacasta
 */

#ifndef GTKHST_GTHREAD_COMPAT_H_
#define GTKHST_GTHREAD_COMPAT_H_


#include <glib.h>
#if GLIB_CHECK_VERSION(2,32,0)
typedef GMutex HstMutex;

#define hst_create_mutex( m ) { \
    g_mutex_init(&(m)); \
}
#define hst_mutex_lock( m ) { \
    g_mutex_lock(&(m)); \
}
#define hst_mutex_unlock( m ) { \
    g_mutex_unlock(&(m)); \
}
#define hst_mutex_trylock( m ) g_mutex_trylock(&(m))
#define hst_mutex_free(m) g_mutex_clear(&(m))

#else
typedef GMutex *HstMutex;

#define hst_create_mutex( m ) { \
    m = g_mutex_new(); \
}
#define hst_mutex_lock( m ) { \
    g_mutex_lock( m ); \
}
#define hst_mutex_unlock( m ) { \
    g_mutex_unlock( m ); \
}
#define hst_mutex_trylock( m ) g_mutex_trylock( m )
#define hst_mutex_free( m ) g_mutex_free( m )

#endif


#endif /* GTKHST_GTHREAD_COMPAT_H_ */
