#ifndef __gtkhistogram_protected__
#define __gtkhistogram_protected__

/**
 * HstCanvas:
 *
 * This structure contains information about the canvas where
 * the histograms will be drawn
 */
struct _HstCanvas {
    int character_height, character_width;
    int small_character_height,small_character_width;
    int canvas_width, canvas_height;
    int wx,wy,wz;
    int ox,oy,oz;
    int px0,px1;
    int py0,py1;
    int pz0,pz1;
    cairo_surface_t *surface;
    cairo_t *cairo;
    HstMutex mutex;
    GdkRectangle cscale;
    char *text_font;
    char *axis_font;
    double line_width;

    gboolean   fixed;  /* TRUE if the axis scale is fixed */
    double xmin, xmax; /* X range */
    double ymin, ymax; /* Y range */
    double zmin, zmax; /* Z range */
    double xstp, ystp, zstp; /* Stip in X, Y and Z axis */
    double mantisa_x, mantisa_y, mantisa_z;
    double exponent_x, exponent_y, exponent_z;
    gboolean   logx,logy;
    double lxmin,lymin;
    GList  *curve_colors;
    PangoLayout *legend;
    int     leg_x,leg_y;
    
    gchar *color_names[HST_NCOLORS];

    /*
     * Stats for a range
     */
    HstStats *stats;
};

/*< private >*/
void canvas_set(HstChart1D *);
/*< private >*/
void canvas_transform(HstCanvas *,double, double , HstPoint *);
/*< private >*/
void canvas_transform_inv(HstCanvas *,int ix, int iy, double *x, double *y);
/*< private >*/
HstPoint * canvas_transform_tuple(HstCanvas *, HstTuple *);


#endif
