#ifndef __HST_CHART2D_H__
#define __HST_CHART2D_H__

#include <gtkhst/hstchart1d.h>
#include <gtkhst/histogram2d.h>

G_BEGIN_DECLS

/*
 * Type checking and casting macros
 */
#define HST_TYPE_CHART2D	(hst_chart2d_get_type())
#define HST_CHART2D(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), HST_TYPE_CHART2D, HstChart2D)
#define HST_CHART2D_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), HST_TYPE_CHART2D, HstChart2D const)
#define HST_CHART2D_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), HST_TYPE_CHART2D, HstChart2DClass)
#define GTK_IS_HST2D(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), hst_chart2d_get_type ())

#define HST_CHART2D_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), HST_TYPE_CHART2D, HstChart2DClass)

typedef enum {
    HST_COLOR_2D_BW,
    HST_COLOR_2D_WB,
    HST_COLOR_2D_RED,
    HST_COLOR_2D_GREEN,
    HST_COLOR_2D_BLUE,
    HST_COLOR_2D_THERMAL,
    HST_COLOR_2D_LAST
} HstChartColorScheme;
GType hst_chart_color_scheme_get_type (void);
#define HST_TYPE_CHART_COLOR_SCHEME (hst_chart_color_scheme_get_type())


/*
 * Main object structure
 */
typedef struct _HstChart2D HstChart2D;
struct _HstChart2D {
    HstChart1D __parent__;
    HstChartColorScheme ctype;
    int       ncol;
    GdkColor  *colorlst;

    gboolean squared;
    
    /* Data stored in order */
    int ntot;
    int nindx;
    int bsiz;

    gint      *dindex,*dkey;
};

/*
 * Class definition
 */
typedef struct _HstChart2DClass HstChart2DClass;
struct _HstChart2DClass {
	HstChart1DClass __parent__;
};


/*
 * Public methods
 */
GType	hst_chart2d_get_type	(void);
GtkWidget *hst_chart2d_new  (HstHistogram2D *f2d);
void       hst_chart2d_set_squared(HstChart2D *h2d, gboolean squared);
G_END_DECLS
#endif
