#ifndef __HST_GAUGE_H__
#define __HST_GAUGE_H__

#include <gdk/gdk.h>
#include <gtk/gtk.h>

G_BEGIN_DECLS

#define HST_TYPE_GAUGE            (hst_gauge_get_type ())
#define HST_GAUGE(obj)            (G_TYPE_CHECK_INSTANCE_CAST  ((obj), HST_TYPE_GAUGE, HstGauge))
#define HST_GAUGE_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), HST_TYPE_GAUGE, HstGaugeClass))
#define HST_IS_GAUGE(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HST_TYPE_GAUGE))
#define HST_IS_GAUGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HST_TYPE_GAUGE))
#define HST_GAUGE_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), HST_TYPE_GAUGE, HstGaugeClass))

typedef struct _HstGauge HstGauge;
typedef struct _HstGaugeClass HstGaugeClass;
typedef struct _HstGaugePrivate HstGaugePrivate;
struct _HstGauge {
    GtkDrawingArea  widget;
    HstGaugePrivate *priv;
    gfloat     val;         /* value */
    gfloat     xmin, xmax;  /* range */
    gchar     *title;
    gchar     *color;

    gboolean squared;
};

struct _HstGaugeClass {
    GtkDrawingAreaClass parent_class;
};


GType      hst_gauge_get_type (void);
GtkWidget *hst_gauge_new (gfloat xmin, gfloat xmax);
void       hst_gauge_set_value (HstGauge *gg, float v);
gfloat     hst_gauge_get_value (HstGauge *gg);
void       hst_gauge_set_range (HstGauge *gg, gfloat xmin, gfloat xmax);
void       hst_gauge_set_color (HstGauge * gg, const char *cnam);
void       hst_gauge_set_title (HstGauge * gg, const char *cnam);
char *     hst_gauge_get_title (HstGauge *gg);
void       hst_gauge_set_squared(HstGauge *gg, gboolean squared);
/*
  void       hst_gauge_set_tick_font(HstGauge *gg, const char *);
  void       hst_gauge_set_label_font(HstGauge *gg, const char *);
*/
G_END_DECLS
#endif
