/*
 * PythonPlugin.h
 *
 *  Created on: Jan 13, 2012
 *      Author: lacasta
 */

#ifndef PYTHONPLUGIN_H_
#define PYTHONPLUGIN_H_

#include <Plugin.h>


class PythonPlugin: public Plugin
{
    private:
        PyObject *_instance_;
        PyObject *_module_;
        PyObject *_newfile_, *_sor_, *_eor_, *_newevt_, *_newpoint_, *_filter_, *_data_format_;

    public:
        PythonPlugin(const char *module, const char *hook);
        virtual ~PythonPlugin();

        void new_file(std::string &S);
        int start_of_run(int run_type, int nevts, int sample_size);
        bool new_event(int ievt);
        void new_point(std::string &S);
        void end_of_run(std::string &S);
        int filter_event(const AlibavaData *, std::string &S);
        void get_data_format(std::string &data_format);

        PyObject *module() { return _module_; }
        bool good() const { return _instance_ != 0; }
};

#endif /* PYTHONPLUGIN_H_ */
