/* soapalibavaSOAPService.h
   Generated by gSOAP 2.8.17r from /Users/lacasta/workspace/alibava/soap/alibava-soap.h

Copyright(C) 2000-2013, Robert van Engelen, Genivia Inc. All Rights Reserved.
The generated code is released under one of the following licenses:
GPL or Genivia's license for commercial use.
This program is released under the GPL with the additional exemption that
compiling, linking, and/or using OpenSSL is allowed.
*/

#ifndef soapalibavaSOAPService_H
#define soapalibavaSOAPService_H
#include "soapH.h"
class SOAP_CMAC alibavaSOAPService : public soap
{ public:
	/// Constructor
	alibavaSOAPService();
	/// Construct from another engine state
	alibavaSOAPService(const struct soap&);
	/// Constructor with engine input+output mode control
	alibavaSOAPService(soap_mode iomode);
	/// Constructor with engine input and output mode control
	alibavaSOAPService(soap_mode imode, soap_mode omode);
	/// Destructor, also frees all deserialized data
	virtual ~alibavaSOAPService();
	/// Delete all deserialized data (with soap_destroy and soap_end)
	virtual	void destroy();
	/// Delete all deserialized data and reset to defaults
	virtual	void reset();
	/// Initializer used by constructor
	virtual	void alibavaSOAPService_init(soap_mode imode, soap_mode omode);
	/// Create a copy
	virtual	alibavaSOAPService *copy() SOAP_PURE_VIRTUAL;
	/// Close connection (normally automatic)
	virtual	int soap_close_socket();
	/// Force close connection (can kill a thread blocked on IO)
	virtual	int soap_force_close_socket();
	/// Return sender-related fault to sender
	virtual	int soap_senderfault(const char *string, const char *detailXML);
	/// Return sender-related fault with SOAP 1.2 subcode to sender
	virtual	int soap_senderfault(const char *subcodeQName, const char *string, const char *detailXML);
	/// Return receiver-related fault to sender
	virtual	int soap_receiverfault(const char *string, const char *detailXML);
	/// Return receiver-related fault with SOAP 1.2 subcode to sender
	virtual	int soap_receiverfault(const char *subcodeQName, const char *string, const char *detailXML);
	/// Print fault
	virtual	void soap_print_fault(FILE*);
#ifndef WITH_LEAN
	/// Print fault to stream
#ifndef WITH_COMPAT
	virtual	void soap_stream_fault(std::ostream&);
#endif
	/// Put fault into buffer
	virtual	char *soap_sprint_fault(char *buf, size_t len);
#endif
	/// Disables and removes SOAP Header from message
	virtual	void soap_noheader();
	/// Get SOAP Header structure (NULL when absent)
	virtual	const SOAP_ENV__Header *soap_header();
	/// Run simple single-thread iterative service on port until a connection error occurs (returns error code or SOAP_OK), use this->bind_flag = SO_REUSEADDR to rebind for a rerun
	virtual	int run(int port);
	/// Bind service to port (returns master socket or SOAP_INVALID_SOCKET)
	virtual	SOAP_SOCKET bind(const char *host, int port, int backlog);
	/// Accept next request (returns socket or SOAP_INVALID_SOCKET)
	virtual	SOAP_SOCKET accept();
#if defined(WITH_OPENSSL) || defined(WITH_GNUTLS)
	/// Then accept SSL handshake, when SSL is used
	virtual	int ssl_accept();
#endif
	/// Serve this request (returns error code or SOAP_OK)
	virtual	int serve();
	/// Used by serve() to dispatch a request (returns error code or SOAP_OK)
	virtual	int dispatch();

	///
	/// Service operations (you should define these):
	/// Note: compile with -DWITH_PURE_VIRTUAL for pure virtual methods
	///

	/// Web service operation 'getStatus' (returns error code or SOAP_OK)
	virtual	int getStatus(int getStatusRequest, struct ns1__getStatusResponse &_param_1) SOAP_PURE_VIRTUAL;

	/// Web service operation 'getMonitorData' (returns error code or SOAP_OK)
	virtual	int getMonitorData(int getMonitorDataRequest, struct ns1__getMonitorDataResponse &_param_2) SOAP_PURE_VIRTUAL;

	/// Web service operation 'getEventData' (returns error code or SOAP_OK)
	virtual	int getEventData(int getEventDataRequest, struct ns1__getEventDataResponse &_param_3) SOAP_PURE_VIRTUAL;

	/// Web service operation 'getEventHeaders' (returns error code or SOAP_OK)
	virtual	int getEventHeaders(int getEventHeadersRequest, struct ns1__getEventHeadersResponse &_param_4) SOAP_PURE_VIRTUAL;

	/// Web service operation 'startRun' (returns error code or SOAP_OK)
	virtual	int startRun(ns1__DAQParam *daqParam, struct ns1__startRunResponse &_param_5) SOAP_PURE_VIRTUAL;

	/// Web service operation 'stopRun' (returns error code or SOAP_OK)
	virtual	int stopRun(int stopRunRequest, struct ns1__stopRunResponse &_param_6) SOAP_PURE_VIRTUAL;

	/// Web service operation 'getRunData' (returns error code or SOAP_OK)
	virtual	int getRunData(int getRunDataParam, struct ns1__getRunDataResponse &_param_7) SOAP_PURE_VIRTUAL;

	/// Web service operation 'setDataFile' (returns error code or SOAP_OK)
	virtual	int setDataFile(std::string dataFile, struct ns1__setDataFileResponse &_param_8) SOAP_PURE_VIRTUAL;

	/// Web service operation 'setParameter' (returns error code or SOAP_OK)
	virtual	int setParameter(ns1__ParValue *parValue, struct ns1__setParameterResponse &_param_9) SOAP_PURE_VIRTUAL;

	/// Web service one-way operation 'startRunAsync' (return error code, SOAP_OK (no response), or send_startRunAsync_empty_response())
	virtual	int startRunAsync(ns1__DAQParam *daqParam) SOAP_PURE_VIRTUAL;
	virtual	int send_startRunAsync_empty_response(int httpcode) { return soap_send_empty_response(this, httpcode); }

	/// Web service one-way operation 'Reset' (return error code, SOAP_OK (no response), or send_Reset_empty_response())
	virtual	int Reset(int resetParam) SOAP_PURE_VIRTUAL;
	virtual	int send_Reset_empty_response(int httpcode) { return soap_send_empty_response(this, httpcode); }

	/// Web service operation 'getMask' (returns error code or SOAP_OK)
	virtual	int getMask(int getMaskRequest, struct ns1__getMaskResponse &_param_12) SOAP_PURE_VIRTUAL;

	/// Web service operation 'getHistogram' (returns error code or SOAP_OK)
	virtual	int getHistogram(ns1__ParValue *parValue, struct ns1__getHistogramResponse &_param_13) SOAP_PURE_VIRTUAL;

	/// Web service operation 'getTriggerCounter' (returns error code or SOAP_OK)
	virtual	int getTriggerCounter(int getTriggerCounterRequest, struct ns1__getTriggerCounterResponse &_param_14) SOAP_PURE_VIRTUAL;

	/// Web service operation 'setDAQConfig' (returns error code or SOAP_OK)
	virtual	int setDAQConfig(ns1__DAQConfig *daqConfig, struct ns1__setDAQConfigResponse &_param_15) SOAP_PURE_VIRTUAL;
};
#endif
