/*
 * AlibavaDataQueue.h
 *
 *  Created on: Jun 20, 2014
 *      Author: lacasta
 */

#ifndef ALIBAVADATAQUEUE_H_
#define ALIBAVADATAQUEUE_H_
#include <glib.h>
#include <deque>
#include <DataFormat.h>


class AlibavaDataQueue
{
    private:
        GCond *condition;
        GMutex *data_mutex, *data_guard;
        std::deque<AlibavaData *> queue;
        void clear();

        class Guard {
            private:
                GMutex *mtx;
            public:
                Guard(GMutex *M) : mtx(M) { g_mutex_lock(mtx); }
                ~Guard() { g_mutex_unlock(mtx); }
        };
    public:
        AlibavaDataQueue();
        virtual ~AlibavaDataQueue();

        /** wait for the condition
         *  time_out is the time in milliseconds (if negative wait for ever)
         */
        int wait(int time_out=-1);
        void push(AlibavaData *data);
        AlibavaData *pop();
        bool empty();

};

#endif /* ALIBAVADATAQUEUE_H_ */
