/* -*- mode: c++ -*- */
#ifndef __BeetleConfig_h__
#define __BeetleConfig_h__

#include <string>
#include <map>
#include <iosfwd>
#include <ConfigFile.h>
#include <ComparatorConfig.h>

class Alibava;

class BeetleConfig : public ConfigFile
{
    public:
        typedef std::map<std::string, unsigned short> VarList;
    private:
        short _mask;
        ComparatorConfig _comparator;
        void cpy(const BeetleConfig &b);
        std::map<unsigned short, std::string> parindx;

        VarList varlist;

    public:
        BeetleConfig();
        BeetleConfig(const BeetleConfig &b)
        {
            cpy(b);
        }
        ~BeetleConfig()
        {
        }

        BeetleConfig &operator=(const BeetleConfig &b)
        {
            if ( this!=&b)
                cpy(b);

            return *this;
        }

        ComparatorConfig &get_comparator_settings();
        unsigned short set_comparator_settings();
        unsigned short set_comparator_settings(const ComparatorConfig &C);

        void load_data();
        void save_data();

        short mask() const { return _mask; }
        void  mask(short x);

        int size() const { return varlist.size(); }
        VarList::const_iterator begin() const {return varlist.begin(); }
        VarList::const_iterator end() const { return varlist.end(); }
        unsigned short operator()(const std::string &var);
        int set(unsigned short, unsigned short, Alibava *A=0);
        int set(const std::string &name, unsigned short, Alibava *A=0);


        void setup_easy(Alibava *A=0);

        unsigned short set_value(const std::string param, unsigned short val, Alibava *A=0);
        int config_beetle(int nval, unsigned short *val, Alibava *A=0);
        int config_beetle_comparator(Alibava *A);
        int config_beetle_thresholds(Alibava *A, int ichip, ComparatorConfig *comp=0);

};
std::ostream &operator<<(std::ostream &os, const BeetleConfig &B);
#endif
