/*
 * ConfigFactory.h
 *
 *  Created on: May 17, 2010
 *      Author: lacasta
 */

#ifndef CONFIGFACTORY_H_
#define CONFIGFACTORY_H_

#include <map>
#include <string>
#include <ConfigFile.h>

class KeyFile;
class Alibava;

class ConfigFactory
{
    private:
        bool _easy;
        std::map<std::string, ConfigFile *> config_map;
    protected:
        ConfigFactory();

    public:
        static ConfigFactory *instance();
        ~ConfigFactory();

        void set_file(KeyFile *);
        void save_data();
        ConfigFile *get(const std::string &name);

        int config_beetle(Alibava &B);
        int config_beetle_comparator(Alibava &B);
        int config_trigger(Alibava &B);
        int config_board(Alibava &B);

        /*
         * This is to make it "educational"
         */
        bool easy() const { return _easy; }
        void easy(bool z) { _easy = z; }
};

#endif /* CONFIGFACTORY_H_ */
